unit nuholnik;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Image1: TImage;
    Image2: TImage;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    Button3: TButton;
    Image3: TImage;
    Label4: TLabel;
    TrackBar1: TTrackBar;
    Label5: TLabel;
    MainMenu1: TMainMenu;
    Subor1: TMenuItem;
    Koniec1: TMenuItem;
    Pomoc1: TMenuItem;
    Oprograme1: TMenuItem;
    Edit4: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Oprograme1Click(Sender: TObject);
    procedure Koniec1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure kresli();
    procedure kresliRotaciu();
    procedure pocitaj();
    procedure rotuj();

  end;

var
  Form1: TForm1;
  vrcholy : array of array[0..1] of integer;
  stred : array[0..1] of integer;
  uhol,polomer,pocetN,rychlost,j: integer;
  alfa : real;

implementation

uses Unit4;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);

begin
    uhol:= StrToInt(Edit1.text);
    if (uhol < 1) then
    begin
      showmessage('Uhol otacania musi byt vetcsi ako 0, uhol bol nastaveny na 1');
      uhol :=1;
    end;
    if (uhol > 360) then
    begin
      showmessage('Uhol otacania musi byt mensi ako 361, uhol bol nastaveny na 360');
      uhol :=360;
    end;
    rychlost:= StrToInt(Edit4.Text);
    if (rychlost < 10)then
    begin
      showmessage('Rychlost otacania musi byt vetcsia ako 10, rychlost bola nastavena na 10');
      rychlost := 10;
    end;
    polomer:= StrToInt(Edit2.text);
    if (polomer < 20)
    then
    begin
     showmessage('Polomer musi byt vetcsi ako 20, polomer je nastaveny na 20');
     polomer:=20;
    end;
    pocetN:= StrToInt(Edit3.text);
    if (pocetN < 3)
    then
    begin
     showmessage('Pocet stran N-uholnika musi byt vetcsi ako 3, pocet stran N je nastaveny na 3');
     pocetN:=3;
    end;
    Button2.Enabled := True;
    kresli;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  stred[0]:=250;
  stred[1]:=250;
  j:=1;
  Button2.Enabled := False;
  Button3.Enabled := False;
  Image3.Canvas.Brush.Color := Image1.Canvas.Pen.Color;
  Image3.Canvas.FillRect(ClientRect);
  Image1.Canvas.FillRect(ClientRect);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  stred[0]:=X;
  stred[1]:=image1.height-Y;
end;

procedure TForm1.kresli;
var i:integer;
begin
  Label8.Caption:='X: '+inttostr(stred[0])+' Y: '+inttostr(stred[1]);
  pocitaj;
  image1.Canvas.Brush.Color:=clwhite;
  image1.Canvas.Brush.Style:=bsSolid;;
  Image1.Canvas.FillRect(Image1.ClientRect);//Rectangle(0,0,image1.Width,image1.Height);
  //image1.Canvas.Pen.Color:=clblack;
  //image1.Canvas.Brush.Color:=clred;

  image1.Canvas.MoveTo(vrcholy[0,0],vrcholy[0,1]);

  //image1.canvas.Ellipse(stred[0]-polomer,image1.Height-stred[1]-polomer,stred[0]+polomer,image1.Height-stred[1]+polomer);

  for I := 0 to pocetN - 1 do
    begin
      image1.Canvas.LineTo(vrcholy[i,0],vrcholy[i,1]);
    end;
  image1.Canvas.LineTo(vrcholy[0,0],vrcholy[0,1]);

  image1.Repaint;

end;

procedure TForm1.pocitaj;
var i:integer;

begin
  setlength(vrcholy,pocetN);
  alfa:=(2*PI)/pocetN;

  for I := 0 to pocetN - 1 do
    begin
      vrcholy[i,0]:=stred[0]+round(sin((i)*alfa)*polomer);
      vrcholy[i,1]:=image1.Height-stred[1]+round((cos((i)*alfa))*polomer);
    end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Button2.Enabled := False;
  Button3.Enabled := True;
  Timer1.Enabled := True;
end;

procedure TForm1.rotuj;
var i: integer;
    alfaN: real;
begin
    setlength(vrcholy,pocetN);
    alfa:=(2*PI)/pocetN;
    alfaN:=((uhol*j)*PI)/180;

    for i := 0 to pocetN - 1 do
    begin
      vrcholy[i,0]:=stred[0]+round(sin(((i)*alfa)+alfaN)*polomer);
      vrcholy[i,1]:=image1.Height-stred[1]+round(cos(((i)*alfa)+alfaN)*polomer);
      if (i= pocetN -1) then
      begin
         inc(j);
      end;
    end;

end;

procedure TForm1.kresliRotaciu;
var i:integer;
begin

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i : integer;
begin
  Timer1.Interval := rychlost;
  Label8.Caption:='X: '+inttostr(stred[0])+' Y: '+inttostr(stred[1]);
  rotuj;
    image1.Canvas.Brush.Color:=clwhite;
    image1.Canvas.Brush.Style:=bsSolid;;
    Image1.Canvas.FillRect(Image1.ClientRect);
    //Image1.Canvas.Pen.Color:=clblack;
    //Image1.Canvas.Brush.Color:=clwhite;

    Image1.Canvas.MoveTo(vrcholy[0,0],vrcholy[0,1]);

    //Image1.canvas.Ellipse(stred[0]-polomer,image1.Height-stred[1]-polomer,stred[0]+polomer,image1.Height-stred[1]+polomer);

    for i := 0 to pocetN - 1 do
    begin
      image1.Canvas.LineTo(vrcholy[i,0],vrcholy[i,1]);
    end;
    Image1.Canvas.LineTo(vrcholy[0,0],vrcholy[0,1]);

    Image1.Repaint;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Timer1.Enabled := False;
  Button2.Enabled := True;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Image1.Canvas.Pen.Color := Image2.Canvas.Pixels[X, Y];
  Image3.Canvas.Brush.Color := Image1.Canvas.Pen.Color;
  Image3.Canvas.FillRect(ClientRect);

end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Image1.Canvas.pen.Width:=Trackbar1.Position;
end;


procedure TForm1.Koniec1Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.Oprograme1Click(Sender: TObject);
begin
    Form4.Visible:=True;
end;

end.
